﻿using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;

namespace NiuniuRichEDIT
{

    [StructLayout(LayoutKind.Sequential)]
    struct CHARRANGE
    {
        public int cpMin;
        public int cpMax;
    };

    [StructLayout(LayoutKind.Sequential)]
    struct NMHDR
    {
        public IntPtr hwndFrom;
        public IntPtr idFrom;
        public int code;
    };

    [StructLayout(LayoutKind.Sequential)]
    struct ENLINK
    {
        public NMHDR nmhdr;
        public int msg;
        public IntPtr wParam;
        public IntPtr lParam;
        public CHARRANGE chrg;
    };    

    public class WrapperMsg
    {
        public const int EN_PASTE = 0x0800;	// 粘贴消息
        public const int WM_NOTIFY = 0x004E;	// 粘贴消息
        public const int FALSE = 0;
        public const int TRUE = 1;
        public const int EN_LINK = 0x070b;  //链接点击事件
        public const int WM_LBUTTONDOWN = 0x0201;  //鼠标按下消息 
    }

    public class RichEditWrapper
    {
        [DllImport("RichEditWrapper.dll")]
        public static extern int Niuniu_InitRichEditWnd(IntPtr hParentHwnd, IntPtr hRichEdit);
        [DllImport("RichEditWrapper.dll")]
        public static extern int Niuniu_InsertImage(IntPtr hWnd, [MarshalAs(UnmanagedType.LPWStr)]string strFilePath);
        [DllImport("RichEditWrapper.dll")]
        public static extern void Niuniu_PasteMsg(IntPtr hWnd, IntPtr pasteAddr);

        [DllImport("RichEditWrapper.dll")]
        public static extern IntPtr Niuniu_GetRichTextContent(IntPtr hWnd);

        [DllImport("RichEditWrapper.dll")]
        public static extern int Niuniu_SetStartIndent(IntPtr hWnd, int nSize);
        [DllImport("RichEditWrapper.dll")]
        public static extern void Niuniu_SetDefaultFont(IntPtr hWnd, [MarshalAs(UnmanagedType.LPWStr)]string lpFontName, int nFontSize,
        UInt32 clrText, int bBold, int bItalic, int bUnderLine, int bIsLink);
//         [DllImport("RichEditWrapper.dll")]
//         public static extern void Niuniu_ReplaceSelWithDefaultFont(IntPtr hWnd, [MarshalAs(UnmanagedType.LPWStr)]string lpszText);

        [DllImport("RichEditWrapper.dll")]
        public static extern void Niuniu_ReplaceSel(IntPtr hWnd, [MarshalAs(UnmanagedType.LPWStr)]string lpszText, [MarshalAs(UnmanagedType.LPWStr)]string lpFontName, Int16 nFontSize,
        UInt32 clrText, int bBold, int bItalic, int bUnderLine, int bIsLink, int nIndent);

        [DllImport("RichEditWrapper.dll")]
        public static extern void Niuniu_AppendMsg(IntPtr hWnd, [MarshalAs(UnmanagedType.LPWStr)]string strText);

        [DllImport("RichEditWrapper.dll")]
        public static extern int Niuniu_SetSel(IntPtr hWnd, System.Int32 nStartChar, System.Int32 nEndChar);

        [DllImport("RichEditWrapper.dll")]
        public static extern int Niuniu_GetSel(IntPtr hWnd, ref System.Int32 nStartChar, ref System.Int32 nEndChar);

        [DllImport("RichEditWrapper.dll")]
        public static extern IntPtr Niuniu_GetSelText(IntPtr hWnd, System.Int32 nStartChar, System.Int32 nEndChar);

        [DllImport("RichEditWrapper.dll")]
        public static extern int Niuniu_HasOleObjectFromPoint(IntPtr hWnd, int xPos, int yPos);

        [DllImport("RichEditWrapper.dll")]
        public static extern int Niuniu_SaveOleObjectFromPoint(IntPtr hWnd, int xPos, int yPos);

         [DllImport("RichEditWrapper.dll")]
        public static extern IntPtr Niuniu_GetOleObjectPathFromPoint(IntPtr hWnd, int xPos, int yPos);
        
        public static string GetRichTextContent(IntPtr hWnd)
        {
            IntPtr ptrContent = Niuniu_GetRichTextContent(hWnd);
            string strContent = Marshal.PtrToStringUni(ptrContent);
            return strContent;
        }

        public static string GetOleObjectPathFromPoint(IntPtr hWnd, int xPos, int yPos)
        {
            IntPtr ptrContent = Niuniu_GetOleObjectPathFromPoint(hWnd, xPos, yPos);
            string strContent = Marshal.PtrToStringUni(ptrContent);
            return strContent;
        }

        public static string GetSelContent(IntPtr hWnd, int nMin, int nMax)
        {
            IntPtr ptrContent = Niuniu_GetSelText(hWnd, nMin, nMax);
            string strContent = Marshal.PtrToStringUni(ptrContent);
            return strContent;
        }
    }
}